clc;clf;clear;close all;

global m1 m2 I1 I2 l1 l2 d lc1 lc2 b1 b2 c1 c2 K g vr Kp1 Ki1 Kd1 Kp2 Ki2 Kd2 prevError omega j reference ...
    b prevTime integrale derivative simDuration T Tprev

b = 0.04;h=0.05;l=0.11;
rho = 1060;

M = 0.043;
%M = 0.75*rho*((b*l*h) - (b-0.02)*l*(h-0.02))
%I = M*(h^2 + l^2)/12 - M*((h-0.02)^2 + l^2)/12;

I = 300*10^-6;%748.818*10^-6;76*10^-6

m1 = 3.499;m2 = 1.232;I1 = 0.09;I2 = 0.033;l1 = 0.5;l2 = 0.5;d = 0.6;%0.6/(0.5/l)
lc1 = 0.414;lc2 = 0.333;b1 = 0.02;b2 = 0.14;c1 = 0.02;c2 = 0.45;K = 1.752;g = 9.81;
Kp1 = 0;Ki1 = 0;Kd1 = 0;%Kp1 = 6/9/13;Kp1 = 19, Kd1 = 0.041/0.7
Kp2 = 0;Ki2 = 0;Kd2 = 0;%Kp2 = 0.35/0.09/0.01,Kp2 = 0.35, Kd2 = 0.056/0.041,Kd2 = 0.054/0.040
prevError = 0;
omega = 2.513; %2.513
j=1;
prevTime = 0;
integrale = 0; derivative = 0;
Tprev = 0;

q10 = acos(d/(2*l1))+3*pi/2-2*pi;q20 = 2*asin(d/(2*l1))-pi;%5.2528;4.1720; %initial angles
qp10 = 0;qp20 = 0;%2*pi/(0.12*6); %initial angular velocities
%q30 = q10 + 0.5*q20;qp30 = qp10 + 0.5*qp20;
simDuration = 0.9; %duration of the simulation

options = odeset('RelTol', 1e-8);
t = 0:0.01:simDuration;
q0 = [q10; qp10; q20; qp20]; %initial data

vr = zeros(2,length(t));
reference = zeros(2,length(t));
T = zeros(2,length(t));

[t,q] = ode45('equadiff', t, q0, options);

xmin = min(l1*sin(q(:,1)) + l2*sin(q(:,1)+q(:,3)));xmax = max(l1*sin(q(:,1)) + l2*sin(q(:,1)+q(:,3)));
ymin = min(-l1*cos(q(:,1)) - l2*cos(q(:,1)+q(:,3)));
ymax = 0.02+(-sign(max(-l1*cos(q(:,1)) - l2*cos(q(:,1)+q(:,3))))-1)*max(-l1*cos(q(:,1)) - l2*cos(q(:,1)+q(:,3)))/-2;

% writerObj = VideoWriter('brachiation.avi');
% open(writerObj);
% Z = peaks; surf(Z); 
% axis tight
% set(gca,'nextplot','replacechildren');
% set(gcf,'Renderer','zbuffer');

for i=1:length(t)
    tic
    figure(1)
    subplot(1,1,1,'replace');grid on;hold on;axis(1.2*[xmin xmax ymin ymax]);
    line([0 l1*sin(q(i,1))], [0 -l1*cos(q(i,1))],'LineWidth',3,'Color','b');
    plot(0,0,'k.','Markersize',30);
    plot(l1*sin(q(i,1)),-l1*cos(q(i,1)),'b.','Markersize',40);
    line([l1*sin(q(i,1)) l1*sin(q(i,1))+l2*sin(q(i,1)+q(i,3))], [-l1*cos(q(i,1)) -l1*cos(q(i,1))-l2*cos(q(i,1)+q(i,3))],'LineWidth',3,'Color','b');
    plot(l1*sin(q(i,1))+l2*sin(q(i,1)+q(i,3)),-l1*cos(q(i,1))-l2*cos(q(i,1)+q(i,3)),'k.','Markersize',30);
    plot(d,0,'x','LineWidth',2,'MarkerSize',10,'Color','r');
    drawnow;
    %frame = getframe;
    %writeVideo(writerObj,frame);
    while toc<0.04;end;
end

% close(writerObj);

figure(2)
grid on;hold on;
plot(t,60*(q(:,2)/pi)*180/360,'LineWidth',2,'Color','b');
plot(t,60*(q(:,4)/pi)*180/360,'LineWidth',2,'Color','r');
xlabel('t(s)');ylabel('Angular velocity(rpm)');

figure(3)
grid on;hold on;
plot(t,q(:,1),'LineWidth',2,'Color','b');
plot(t,q(:,3),'LineWidth',2,'Color','r');
%plot(t,((4*pi-2*3.7851)/simDuration)*t + 3.7851);
%plot(reference(2,1:j-1),reference(1,1:j-1),'LineWidth',2,'Color','g');

figure(4)
grid on;hold on;axis equal;
yc = (d^2)/(4*l1) - l1;
theta0 = atan(-d/yc) + pi;
%theta = 3*pi/2:0.01:5*pi/2;
%r = l1*sqrt(2*(1+cos(q(:,3))));
theta = 0:0.01:2*pi-2*(theta0-pi);
plot(((d^2)/(4*l1) + l1)*sin(theta + theta0),((d^2)/(4*l1) + l1)*-cos(theta + theta0) + (d^2)/(4*l1) - l1,'LineWidth',2,'Color','g');
%plot(r*sin(theta),r*cos(theta),'LineWidth',2,'Color','g');
plot(l1*sin(q(:,1))+l2*sin(q(:,1)+q(:,3)),-l1*cos(q(:,1))-l2*cos(q(:,1)+q(:,3)),'LineWidth',2,'Color','r');
plot(d,0,'x','LineWidth',2,'MarkerSize',15,'Color','b');

% figure(5)
% for i=1:100:length(t)
%     grid on;hold on;axis equal;
%     plot(l1*sin(q(i,1))+l2*sin(q(i,1)+q(i,3)),-l1*cos(q(i,1))-l2*cos(q(i,1)+q(i,3)),'LineWidth',2,'Color','r');
% end
% size(vr)

figure(6)
grid on;hold on;
%plot(vr(2,1:j-1),K*vr(1,1:j-1));
plot(T(2,1:j-1),T(1,1:j-1));
xlabel('t(s)');ylabel('C(N.m)');

%simDuration/(j/40)

%figure(6)
%grid on;hold on;
%plot(vr(2,1:j-1),K*vr(1,1:j-1)*q(:,4));
% figure(4)
% grid on;hold on;
% plot(d*sin(q(:,5)), -d*cos(q(:,5)),'LineWidth',2,'Color','b');
% plot(l1*sin(q(:,1))+l2*sin(q(:,3)),-l1*cos(q(:,1))-l2*cos(q(:,3)),'LineWidth',2,'Color','r');